//
//  GameScene.swift
//  Object_move_Kurage
//
//  Created by ryosuke　ushijima on 2015/01/24.
//  Copyright (c) 2015年 ryosuke　ushijima. All rights reserved.
//

import SpriteKit
import Foundation

class GameScene: SKScene,SKPhysicsContactDelegate {
    var i = 0
    var shot = true
    let target: UInt32 = 0x1 << 0
    let bullet: UInt32 = 0x1 << 1
    let BB: UInt32 = 0x1 << 2
    let ika: UInt32 = 0x1 << 3
    let boss: UInt32 = 0x1 << 5
    
    
    override func didMoveToView(view: SKView) {
        self.physicsWorld.gravity = CGVector(dx: 0, dy: 0)
        self.physicsWorld.contactDelegate = self
        //スプライトノードを作る
        //let spColor = SKColor.yellowColor()
        let mySprite = SKSpriteNode(imageNamed: "boss")
        mySprite.setScale(0.2)
        //スプライドノードをシーンに追加
        mySprite.position = CGPoint(x:CGRectGetMidX(self.frame), y:700)
        mySprite.alpha = 0.0
        
        let hito = SKSpriteNode(imageNamed: "hito1")
        hito.setScale(0.1)
        //スプライドノードをシーンに追加
        hito.position = CGPoint(x:CGRectGetMidX(self.frame),y: 40)

        self.addChild(hito)
        //self.addChild(mySprite)
 /*
        //敵オブジェクトの生成
        let position_1 = CGPoint(x: 410,y: 600)
        let position_2 = CGPoint(x: 610,y: 600)
        let enemy_1 = createObj(SKSpriteNode(imageNamed:"Spaceship"),
            scale: 0.2,
            position: position_1,
            clition: SKPhysicsBody(circleOfRadius:2.0)
        )
        let enemy_2 = createObj(SKSpriteNode(imageNamed:"Spaceship"),
            scale: 0.2,
            position: position_2,
            clition: SKPhysicsBody(circleOfRadius:2.0)
        )
*/

        //Bossアクションを作成
        let action_1 = SKAction.fadeInWithDuration(1)
        let action_2 = SKAction.moveBy(CGVectorMake(0, -100), duration:1)
        let action_3 = SKAction.moveBy(CGVectorMake(0, 100), duration:1)

        //Enemyアクションを作成
        let enemy_create = SKAction.fadeInWithDuration(1)
        let enemy_wave_1 = SKAction.moveBy(CGVectorMake(10, -25), duration:0.5)
        let enemy_wave_2 = SKAction.moveBy(CGVectorMake(-10, -25), duration:0.5)
        let enemy_gostop = SKAction.moveBy(CGVectorMake(0, -50), duration:1.0)
        
        //waitアクション生成
        let wait = SKAction.waitForDuration(1)
//      let wait5 = SKAction.waitForDuration(5)
        let wait_boss = SKAction.waitForDuration(0.5)
        let wait_enemy = SKAction.waitForDuration(0.2)
        
        //フェードイン
        let fadeIn = SKAction.sequence([wait, action_1, wait])
/*
        //wait5は時間を止めるだけなので,実際に使う時は削除
        let enemy_move_1 = SKAction.sequence([enemy_wave_1, enemy_wave_2])
        let enemy_move_2 = SKAction.sequence([enemy_gostop, wait_enemy])
        
        //enemy_1.runAction(Enemy_move_1)
        //enemy_2.runAction(Enemy_move_2)
        let enemy_repeat_1 = SKAction.repeatActionForever(enemy_move_1)
        let enemy_repeat_2 = SKAction.repeatActionForever(enemy_move_2)
        let enemy = SKAction.group([enemy_repeat_1, enemy_repeat_2])
*/
        let allenemy_move = SKAction.group([wait_boss])
        
        
        //let bossmove = SKAction.sequence([action_2, wait_boss, action_3])
        let bossmove = SKAction.sequence([action_2, allenemy_move, action_3])
        let boss = SKAction.sequence([fadeIn, bossmove])
        
        //アクションを無限に実行する
        let boss_repeat = SKAction.repeatActionForever(boss)
        mySprite.runAction(boss_repeat)
        /*
        enemy_1.runAction(enemy_repeat_1)
        enemy_2.runAction(enemy_repeat_2)
        */
    }
    
    
    override func update(currentTime: CFTimeInterval) {
        /* Called before each frame is rendered */
        NSLog("%d¥n",i)
        i++
        var unit = i%310
        if(unit == 0){
            //敵オブジェクトの生成
            let position_1 = CGPoint(x: 410,y: 600)
            let position_2 = CGPoint(x: 610,y: 600)
            let enemy_1 = createObj(SKSpriteNode(imageNamed:"ika3"),
                scale: 0.1,
                position: position_1,
                clition:SKPhysicsBody(circleOfRadius:30.0),
                mask: ika,
                maskt:bullet
            )
            let enemy_2 = createObj(SKSpriteNode(imageNamed:"ika1"),
                scale: 0.1,
                position: position_2,
                clition:SKPhysicsBody(circleOfRadius:30.0),
                mask:ika,
                maskt:bullet
            )
            
            let enemy_create = SKAction.fadeInWithDuration(1)
            let enemy_wave_1 = SKAction.moveBy(CGVectorMake(10, -25), duration:0.5)
            let enemy_wave_2 = SKAction.moveBy(CGVectorMake(-10, -25), duration:0.5)
            let enemy_gostop = SKAction.moveBy(CGVectorMake(0, -50), duration:1.0)
            let wait_enemy = SKAction.waitForDuration(0.2)
            
            let enemy_move_1 = SKAction.sequence([enemy_wave_1, enemy_wave_2])
            let enemy_move_2 = SKAction.sequence([enemy_gostop, wait_enemy])
            
            //enemy_1.runAction(Enemy_move_1)
            //enemy_2.runAction(Enemy_move_2)
            let enemy_repeat_1 = SKAction.repeatActionForever(enemy_move_1)
            let enemy_repeat_2 = SKAction.repeatActionForever(enemy_move_2)
            let enemy = SKAction.group([enemy_repeat_1, enemy_repeat_2])

            enemy_1.runAction(enemy_repeat_1)
            enemy_2.runAction(enemy_repeat_2)
        }
        
    }
    
    func didBeginContact(contact: SKPhysicsContact) {
        
        var firstBody, secondBody: SKPhysicsBody
        // firstを的、secondを弾とする。
        if contact.bodyA.categoryBitMask < contact.bodyB.categoryBitMask {
            firstBody = contact.bodyA
            secondBody = contact.bodyB
        } else {
            firstBody = contact.bodyB
            secondBody = contact.bodyA
        }
        
        // 弾と的が接したときの処理。
        if ((firstBody.categoryBitMask & target != 0) &&
            (secondBody.categoryBitMask & BB != 0)) {
                //secondBody.node!.physicsBody = SKPhysicsBody(circleOfRadius:30.0)
                NSLog("hit")
                firstBody.node!.removeFromParent()
                secondBody.node!.removeFromParent()
                shot = true
                let d = 360/30
                for ( var i = 0 ; i < d ; i++ ) {
                    let bull = createObj(SKSpriteNode(imageNamed:"bullet01"), scale: 0.05, position: contact.contactPoint , clition:SKPhysicsBody(circleOfRadius:2.0) , mask: bullet, maskt: ika)
                    
                    let deg = 30 * i
                    let vector = forcusAngleVector(Double(deg))
                    
                    let bulletAction = SKAction.sequence([SKAction.repeatAction(SKAction.moveBy(vector, duration: 0.3), count: 1) , SKAction.removeFromParent()])
                    
                    bull.runAction(bulletAction)
                }
                
        }
        if ((firstBody.categoryBitMask & bullet != 0) &&
            (secondBody.categoryBitMask & ika != 0)) {
                firstBody.node!.removeFromParent()
                secondBody.node!.removeFromParent()
        }
        
    }
    override func touchesBegan(touches: NSSet, withEvent event: UIEvent) {
        /* Called when a touch begins */
        
        for touch: AnyObject in touches {
            let location = touch.locationInNode(self)
            
            //弾Method
            let move1:SKAction = SKAction.moveTo(location, duration: 1.0)
            let move2:SKAction = SKAction.scaleTo(0.5, duration: 0.3)
            let move3:SKAction = SKAction.fadeOutWithDuration(0.3)
            
            let mg01:SKAction = SKAction.group([move2,move3])
            let ms01:SKAction = SKAction.sequence([move1,mg01,SKAction.removeFromParent()])
            
            if(shot){
            let wepon = createObj(SKSpriteNode(imageNamed: "bullet01"), scale: 0.1, position:location , clition: SKPhysicsBody(circleOfRadius:0.5), mask:BB , maskt: target )
            
            wepon.physicsBody?.dynamic = false
            let targ = createObj(SKSpriteNode(imageNamed:"sight"),scale: 0.1,position: location,clition: SKPhysicsBody(circleOfRadius:0.5),mask:target,maskt:BB )
                shot = false
                
                switch(i%4){
                case 0:wepon.position = CGPointMake((self.size.width/2-200),self.size.height/2-50)
                    
                case 1:wepon.position = CGPointMake((self.size.width/2-200),self.size.height/2)
                    
                case 2:wepon.position = CGPointMake((self.size.width/2+200),self.size.height/2-50)
                    
                case 3:wepon.position = CGPointMake((self.size.width/2+200),self.size.height/2)
                default:break;
                }
                wepon.runAction(ms01)

            }
            
            
            
            
            
        }
    }
    
    //敵オブジェクトの生成関数
    func createObj (Cobj:SKSpriteNode,scale:CGFloat,position:CGPoint,clition:SKPhysicsBody,mask:UInt32,maskt:UInt32)-> SKSpriteNode{
        let targ = Cobj
        targ.setScale(scale)
        targ.position = position
        targ.physicsBody = clition
        targ.physicsBody?.categoryBitMask = mask
        targ.physicsBody?.contactTestBitMask = maskt
        // 重力を無視する。
        targ.physicsBody?.affectedByGravity = false
        // 他の物体がぶつかっても、動かないようにしておく。
        //targ.physicsBody?.dynamic = false
        self.addChild(targ)
        
        return targ
        
    }
    
    func forcusAngleVector(deg:Double) -> CGVector{
        let degree: Double =  deg / 360
        let radi = deg * M_PI / 180.0
        let seed = 60.0
        
        let dx = seed * cos(radi) - seed * sin(radi)
        let dy = seed * cos(radi) + seed * sin(radi)
        
        return CGVectorMake(CGFloat(dx), CGFloat(dy))
    }
    
}
